#INCLUDE	"..\INCLUDE\MAIN.H"

FUNCTION NULLIF(LnSRC1)
	RETURN IIF(EMPTY(LnSRC1), 'NULL', IIF(VARTYPE(LnSRC1)=="C", ;
		['] + ALLTRIM(LnSRC1) + ['], IIF(VARTYPE(LnSRC1)== "D", ['] + DTOC(LnSRC1) + ['], ;
		ALLTRIM(STR(LnSRC1)))))
ENDFUNC

PROCEDURE REANIM
USE KADR!SHBL IN 0 ORDER IDOBJ EXCLUSIVE 
DELETE TAG ALL
SET ORDER TO  IDOBJ
USE MCLS IN 0 ORDER IDCOD EXCLUSIVE 
DELETE TAG ALL
SET ORDER TO  IDCOD

USE SLOV IN 0  EXCLUSIVE 
DELETE TAG ALL
INDEX ON idobj*1000+idcls TAG IDCOD
INDEX ON  TRANSFORM(idobj,"@l 999")+TRANSFORM(idcls,"@l 999")+ffield TAG IDFIELD
INDEX ON  (idobj*1000+idcls)*1000+cod TAG IDID
INDEX ON  scod TAG COD
SET ORDER TO  IDOBJ

RETURN 



FUNCTION OnShutdown()
	IF VARTYPE(oApp) == "O"
		LOCAL llResponse
*--		DO FORM FExit TO llResponse
		llResponse = .T.
		IF llResponse
			CLEAR EVENTS
		ENDIF
	ELSE
		RELEASE ALL
		CLEAR EVENTS
	ENDIF
ENDFUNC

FUNCTION NEWOBJ
	LPARAMETERS tcClass, tuParm1, tuParm2, ;
		tuParm3, tuParm4
	LOCAL lcClass, ;
		lcLibrary, ;
		lnPos, ;
		loObject

	lcClass   = UPPER(tcClass)
	lcLibrary = ''
	IF ',' $ lcClass AND LEFT(lcClass, 1) <> ','
		lnPos     = AT(',', lcClass)
		lcLibrary = ALLTRIM(LEFT(lcClass, lnPos - 1))
		lcClass   = ALLTRIM(SUBSTR(lcClass, lnPos + 1))
		IF lcLibrary $ UPPER(SET('CLASSLIB'))
			lcLibrary = ''
		ELSE
			SET CLASSLIB TO (lcLibrary) ADDITIVE
		ENDIF
	ENDIF

	DO CASE
		CASE pcount() = 1
			loObject = CREATEOBJECT(lcClass)
		CASE pcount() = 2
			loObject = CREATEOBJECT(lcClass, @tuParm1)
		CASE pcount() = 3
			loObject = CREATEOBJECT(lcClass, @tuParm1, @tuParm2)
		CASE pcount() = 4
			loObject = CREATEOBJECT(lcClass, @tuParm1, @tuParm2, @tuParm3)
		CASE pcount() = 5
			loObject = CREATEOBJECT(lcClass, @tuParm1, @tuParm2, @tuParm3, ;
				@tuParm4)
	ENDCASE
	RETURN loObject
ENDFUNC

FUNCTION FormIsObject()
	LPARAMETERS NameForm
	*--  .T.     (- "O")  
	*--   "Form".
	IF PCOUNT() = 0 OR EMPTY(NameForm)
		RETURN (TYPE("_SCREEN.ActiveForm") == "O" AND ;
			UPPER(_SCREEN.ACTIVEFORM.BASECLASS) = "FORM")
	ELSE
		RETURN (TYPE("_SCREEN.ActiveForm") == "O" AND ;
			UPPER(_SCREEN.ACTIVEFORM.BASECLASS) = "FORM" ;
			AND UPPER(NameForm) == UPPER(_SCREEN.ACTIVEFORM.NAME))
	ENDIF
ENDFUNC

FUNCTION SetDSession
	*--     
	SET TALK OFF
	SET NOTIFY OFF
	SET COMPATIBLE OFF
	=CURSORSETPROP("Buffering", 1, 0)
	SET MEMOWIDTH TO 120
	SET SYSFORMATS OFF
	SET HOURS TO 24
	SET FDOW TO 2
	SET SEPARATOR TO "`"
	SET POINT TO "."
	SET ANSI OFF && ON
	SET CENTURY ON
	SET DATE TO GERMAN
	SET SAFETY OFF
	SET MEMOWIDTH TO 80
	SET MULTILOCKS ON && OFF
	SET DELETED OFF
	SET EXCLUSIVE OFF
	SET BELL OFF
	SET NEAR OFF
	SET EXACT OFF
	SET INTENSITY OFF
	SET CONFIRM ON
	SET LOCK OFF
	SET REPROCESS TO 10 SECONDS
	SET NULL OFF
	SET NULLDISPLAY TO " "
	CLEAR MACROS
	#IF !DEBUGMODE
		SET RESOURCE OFF
		SET DEBUG OFF
		SET ESCAPE OFF
	#ELSE
		SET RESOURCE ON
		SET DEBUG ON
		SET ESCAPE ON
	#ENDIF
	SET ASSERTS OFF
	SET CPCOMPILE TO 1251
	RETURN .T.
ENDFUNC

FUNCTION ModifyColor
	*	 
	LPARAMETERS lnColor, lnDelta, lnIndex
	LOCAL ARRAY S_Rgb[3]
	*	   0 - 16`777`216
	lnColor	= MIN( 16777216, MAX( 0, iif( VARTYPE( lnColor ) == 'N', lnColor, 0 )))
	*	   0 -  , 1-, 2-, 3-
	lnIndex	= MIN( 3, MAX( 0, iif( VARTYPE( lnIndex ) == 'N', lnIndex, 0 )))
	*	    
	lnDelta	= IIF( VARTYPE( lnDelta ) == 'N', lnDelta , 0 )

	S_Rgb[3]	= INT( lnColor/ 65536 )	&& 
	lnColor		= lnColor- ( S_Rgb[3] * 65536 )
	S_Rgb[2]	= INT( lnColor/ 256 )	&& 
	lnColor		= lnColor- ( S_Rgb[2] * 256 )
	S_Rgb[1]	= lnColor				&& 

	IF lnIndex = 0	&&  
		RETURN ( rgb(;
			MAX( 0, MIN( 255,  S_Rgb[ 1 ] + lnDelta )),;
			MAX( 0, MIN( 255,  S_Rgb[ 2 ] + lnDelta )),;
			MAX( 0, MIN( 255,  S_Rgb[ 3 ] + lnDelta ))))
	ELSE			&&  
		RETURN ( MAX( 0, MIN( 255,  S_Rgb[ lnIndex ] + lnDelta )))
	ENDIF
ENDFUNC


*--           
FUNCTION Revers
	LPARAMETERS luStr, lnPrecision, lnScale
	DO CASE
		CASE VARTYPE(luStr) == "C"
			luStr = CHRTRAN(NVL(luStr, ""), ["], ["])
			RETURN CHRTRAN(luStr, " !#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWYZ[\]^_`abcdefghijklmnopqrstuvwxyz{|}~", ;
				"~}|{zyxwvutsrqponmlkjihgfedcba`_^]\[ZYWVUTSRQPONMLKJIHGFEDCBA@?>=<;:9876543210/.-,+*)('&%$#! ")
		CASE VARTYPE(luStr) == "N"
			LOCAL lnVal
			luStr = NVL(luStr, 0)
			lnPrecision = IIF(VARTYPE(lnPrecision)=="N", lnPrecision, 18)
			lnScale = IIF(VARTYPE(lnScale)=="N", lnScale, 2)
			lnVal = VAL(REPLICATE('9', lnPrecision - lnScale - IIF(lnScale = 0,0,1)) + ;
				IIF(lnScale = 0,'','.' + REPLICATE('9', lnScale)))
			RETURN IIF(luStr > 0, 'A', 'Z') + ;
				IIF(luStr > 0, STR(lnVal - luStr,lnPrecision,lnScale), STR(-luStr,lnPrecision,lnScale))
		CASE VARTYPE(luStr) = "D"
			luStr = NVL(luStr, {})
			RETURN  STR(99999999 - VAL(DTOS(luStr)))
		CASE VARTYPE(luStr) = "T"
			luStr = NVL(luStr, DTOT({}))
			RETURN STR(99999999 - VAL(DTOS(TTOD(luStr))))
		OTHERWISE
			RETURN ""
	ENDCASE
ENDFUNC

FUNCTION NumToStr
	LPARAMETERS luStr, lnPrecision, lnScale
	luStr = NVL(luStr, 0)
	lnPrecision = IIF(VARTYPE(lnPrecision)=="N", lnPrecision, 18)
	lnScale = IIF(VARTYPE(lnScale)=="N", lnScale, 2)
	RETURN IIF(luStr < 0, 'A', 'Z') + ;
		IIF(luStr < 0, STR(-99999999999999.99 - luStr,lnPrecision,lnScale), STR(luStr,lnPrecision,lnScale))
ENDFUNC

FUNCTION Clasp
	LPARAMETERS codc, codp
	cural=SELECT()
	retval=""
	
     IF USED("NSI")
	SELECT NSI

	SET ORDER TO pid
	LOCATE FOR pid=codc AND kod=codp
	IF FOUND()
		retval=codp+' '+name
	endif
	SELECT(cural)
	ENDIF
	RETURN retval
ENDFUNC


FUNCTION NEXT_COD
PARAMETERS lc_f,lc_ts

IF TYPE("lc_f")!="C"
 lc_f="COD"
ENDIF

IF TYPE("lc_ts")!="L"
 lc_ts=.F.
ENDIF
LOCAL lc_filt,lc_value,i,j,ln_a,lc_alias
LOCAL ARRAY ln_a(1)
ln_a(1)=0
lc_alias=ALIAS()
lc_filt=FILTER()
lc_value=EVALUATE(lc_f)

IF EMPTY(lc_filt)
	lc_filt=".T."
ENDIF	 
IF ! lc_ts
	SELECT MAX(&lc_f) FROM (lc_alias) WHERE .T. INTO ARRAY ln_a && &lc_filt
	IF TYPE("ln_a(1)")!="N"
		RETURN 1
	ELSE
		RETURN (LN_a(1)+1)
	ENDIF
ELSE
	SELECT &lc_f FROM (lc_alias) WHERE  &lc_f>=lc_value  GROUP BY 1 INTO ARRAY ln_a  && &lc_filt AND
	IF ! TYPE("ln_a(1)")=="N"
			RETURN(1)
	ENDIF
	
	j=ln_a(1)
	FOR i=1 TO ALEN(ln_a)
		IF ln_a(i) != j
			EXIT
		ENDIF
		j=j+1
	ENDFOR
	RETURN(ln_a(i-1)+1)
ENDIF
*SET FILTER TO &lc_filt

RETURN ln_a

****************NOT USE 
FUNCTION NEXT_ID 
LPARAMETERS lc_f,lc_alias
IF TYPE("lc_f")!="C"
 lc_f="ID"
ENDIF
IF TYPE("lc_alias")!="C"
	lc_alias=ALIAS()
ENDIF

LOCAL ARRAY ln_a(1)
SELECT MAX(&lc_f) FROM (lc_alias) INTO ARRAY ln_a
	IF ! TYPE("ln_a(1)")=="N"
			RETURN(1)
	ENDIF
RETURN(ln_a(1)+1)

******* NOT USED EXAMPE ONLY
FUNCTION SCAN_U
LPARAMETERS m_pid,m_nod
LOCAL gt_u,gt_rs,gt_filt,m_ret
gt_u=SELECT()
SELECT cALST
IF ! EOF()
	gt_rs=RECNO()
ELSE
	gt_rs=0
ENDIF
gt_filt=FILTER()
SET FILTER TO 

m_ret=.F.
DO WHILE .t.
	IF SEEK(m_pid,"cSHST","ID") 
		IF  cSHST.PID =m_nod
			m_ret=.T.
			EXIT
		ELSE	
			IF 	cSHST.PID==0
				EXIT
			ELSE
				m_pid=cSHST.pid   
				LOOP
			ENDIF
		ENDIF
	ELSE
	EXIT
	ENDIF
ENDDO

SET FILTER TO &gt_filt

IF gt_rs != 0
 GO gt_rs
ENDIF
SELECT (gt_u)
RETURN (m_ret)
*****************************
***************************
FUNCTION max_el
LPARAMETERS in_arr,n_el
EXTERNAL ARRAY in_arr
LOCAL i,rt_v
rt_v=0
FOR i=1 TO ALEN(in_arr,1)
rt_v=MAX(rt_v,in_arr(i,n_el))
ENDFOR
RETURN rt_v+1


PROCEDURE modtable
LPARAMETERS l_obj,l_cls
LOCAL u_u,u_k
LOCAL ARRAY a_fiel(1,1)

u_u=.f.

IF ! USED("SHBL")
	USE SHBL IN 0
	u_u=.t.
ENDIF

SELECT SHBL
LOCATE FOR idobj=l_obj
IF ! FOUND()
 RETURN .F.
ENDIF

mod_f=ALLTRIM(filesyst)
IF u_u
	USE IN shbl
ENDIF


u_k=.f.
IF ! USED(mod_f)
	USE (mod_f) IN 0
	u_k=.t.
ENDIF

=AFIELDS(a_fiel)



u_u=.f.
IF ! USED("SLOV")
	USE SLOV IN 0
	u_u=.t.
ENDIF
SELECT SLOV	

LOCAL c_mcr,n_e,c_typf   
c_mcr=""

SCAN ALL FOR idobj=l_obj AND idcls=l_cls AND typf $ "CNDKMT"

n_e=ASCAN(mas,ALLTRIM(FFIELD),1)
IF n_e =0

DO CASE
CASE typf="N" AND DEC !=0
	c_typf="N("+ALLTRIM(STR(len))+","+ALLTRIM(STR(dec))+")"
CASE typf="N" AND DEC =0
	c_typf="N("+ALLTRIM(STR(len))+")"
CASE typf="K" OR typf="M" OR typf="G"
	c_typf="I"
CASE typf="C"
	c_typf="C("+ALLTRIM(STR(len))+")"
CASE typf="T"
	c_typf="M"
CASE typf="D"
	c_typf="D"
CASE typf="Y"
	c_typf="Y"
ENDCASE

c_mcr=UPPER(ALLTRIM(FFIELD))+" "+c_typf

alter table (mod_f) add COLUMN &c_MCR

ENDIF
ENDSCAN

IF u_u
	USE IN SLOV
ENDIF

IF u_k
	USE IN (mod_f)
ENDIF
RETURN .T.




FUNCTION Calendar(loTextEdit)
	LOCAL loChangeDate AS OBJECT
	loChangeDate=CREATEOBJECT("cdate",loTextEdit)
	loChangeDate.SHOW(1)
	RETURN
ENDFUNC

DEFINE CLASS daylabel AS LABEL
	FONTSIZE=8
	FONTBOLD=.T.
	HEIGHT=16
	WIDTH=18
	ALIGNMENT=2
	BORDERSTYLE=0
	BACKCOLOR=RGB(250,250,250)
	CAPTION=""
	PROCEDURE CLICK
		LOCAL vdt
		vdt=CTOD(THIS.CAPTION+"."+ALLT(STR(THIS.PARENT.vmonth))+"."+ALLT(STR(THIS.PARENT.vyear)))
		IF ! EMPTY(vdt)
			DO CASE
				CASE TYPE("thisform.odat")="D"
					THISFORM.odat=vdt
				CASE TYPE("thisform.odat")="O"
					THISFORM.odat.VALUE=vdt
					THISFORM.odat.REFRESH
			ENDCASE
		ENDIF
		THIS.PARENT.RELEASE
	ENDPROC
	PROCEDURE MOUSEMOVE
		LPARAMETERS nButton, nShift, nXCoord, nYCoord
		IF ! EMPTY(THIS.CAPTION)
			IF THIS.PARENT.vday!=VAL(THIS.CAPTION)
				THIS.PARENT.vday=VAL(THIS.CAPTION)
				THIS.PARENT.olm.CAPTION=ALLT(STR(THIS.PARENT.vday))+" "+THIS.PARENT.mns[this.parent.vmonth]+" "+ALLT(STR(THIS.PARENT.vyear))
			ENDIF
		ENDIF
	ENDPROC
	PROCEDURE RIGHTCLICK
		THISFORM.RELEASE
	ENDPROC
ENDDEFINE

DEFINE CLASS cdcommandbutton AS COMMANDBUTTON
	FONTBOLD=.T.
	FONTSIZE=8
	TOP=21
	WIDTH=26
	HEIGHT=16
	VISIBLE=.T.
	TABSTOP=.F.
ENDDEFINE

DEFINE CLASS dowlabel AS LABEL
	FONTSIZE=8
	FONTBOLD=.F.
	HEIGHT=16
	WIDTH=18
	ALIGNMENT=2
	BORDERSTYLE=0
	TOP=39
	BACKCOLOR=RGB(0,0,254)
	FORECOLOR=RGB(254,254,254)
ENDDEFINE

DEFINE CLASS cDate AS FORM
	odat=.F.
	HEIGHT=161
	WIDTH=135
	BORDERSTYLE=2
	TITLEBAR=0
	SHOWTIPS=.T.
	vday=0
	vmonth=0
	vyear=0
	vd=DATE()
	DECLARE mns[12]
	mns[1]=""
	mns[2]=""
	mns[3]=""
	mns[4]=""
	mns[5]=""
	mns[6]=""
	mns[7]=""
	mns[8]=""
	mns[9]=""
	mns[10]=""
	mns[11]=""
	mns[12]=""
	ADD OBJECT "obml" AS "cdcommandbutton"
	ADD OBJECT "obmr" AS "cdcommandbutton"
	ADD OBJECT "obtd" AS "cdcommandbutton"
	ADD OBJECT "obyl" AS "cdcommandbutton"
	ADD OBJECT "obyr" AS "cdcommandbutton"
	ADD OBJECT "tmer" AS "timer"
	tmer.CYCL=0
	PROCEDURE INIT
		PARAMETERS  cDate
		IF PARAMETERS()=0
			cDate=DATE()
		ENDIF
		_scw=_SCREEN.WIDTH
		_sch=_SCREEN.HEIGHT
		_mc=MCOL("",3)
		_mr=MROW("",3)
		DO CASE
			CASE (_sch-_mr>THIS.HEIGHT).AND.(_scw-_mc>THIS.WIDTH)
				THIS.LEFT=_mc-3
				THIS.TOP=_mr-3
			CASE (_sch-THIS.HEIGHT>0).AND.(_scw-_mc>THIS.WIDTH)
				THIS.LEFT=_mc-3
				THIS.TOP=_mr+3-THIS.HEIGHT
			CASE (_sch-_mr>THIS.HEIGHT).AND.(_scw-THIS.WIDTH>0)
				THIS.LEFT=_mc+3-THIS.WIDTH
				THIS.TOP=_mr-3
			CASE (_sch-THIS.HEIGHT>0).AND.(_scw-THIS.WIDTH>0)
				THIS.LEFT=_mc+3-THIS.WIDTH
				THIS.TOP=_mr+3-THIS.HEIGHT
			OTHERWISE
				THIS.LEFT=_mc-THIS.WIDTH/2
				THIS.TOP=_mr-THIS.HEIGHT/2
		ENDCASE
*		SET DATE FRENCH
		THIS.odat=cDate
		DO CASE
			CASE TYPE("cDate")="D"
				THIS.vd=cDate
				THIS.vday=IIF(EMPTY(cDate),DAY(DATE()),DAY(cDate))
				THIS.vmonth=IIF(EMPTY(cDate),MONTH(DATE()),MONTH(cDate))
				THIS.vyear=IIF(EMPTY(cDate),YEAR(DATE()),YEAR(cDate))
			CASE TYPE("cDate")="O"
				THIS.vd=cDate.VALUE
				THIS.vday=IIF(EMPTY(cDate.VALUE),DAY(DATE()),DAY(cDate.VALUE))
				THIS.vmonth=IIF(EMPTY(cDate.VALUE),MONTH(DATE()),MONTH(cDate.VALUE))
				THIS.vyear=IIF(EMPTY(cDate.VALUE),YEAR(DATE()),YEAR(cDate.VALUE))
		ENDCASE

		THIS.ADDOBJECT("olm","label")
		WITH THIS.olm
			.FONTBOLD=.T.
			.FONTSIZE=8
			.BORDERSTYLE=1
			.BACKCOLOR=RGB(255,255,255)
			.TOP=2
			.WIDTH=131
			.ALIGNMENT=2
			.HEIGHT=18
			.VISIBLE=.T.
			.LEFT=(THISFORM.WIDTH-.WIDTH)/2
		ENDWITH

		WITH THIS.obml
			.TOOLTIPTEXT=" "
			.CAPTION="<"
			.LEFT=28
		ENDWITH

		WITH THIS.obtd
			.TOOLTIPTEXT=""
			.CAPTION="*"
			.LEFT=THISFORM.WIDTH/2-12
		ENDWITH


		WITH THIS.obmr
			.TOOLTIPTEXT=" "
			.CAPTION=">"
			.LEFT=THISFORM.WIDTH-53
		ENDWITH

		WITH THIS.obyl
			.TOOLTIPTEXT=" "
			.CAPTION="<<"
			.LEFT=2
		ENDWITH

		WITH THIS.obyr
			.TOOLTIPTEXT=" "
			.CAPTION=">>"
			.LEFT=THISFORM.WIDTH-27
		ENDWITH

		FOR i=1 TO 7
			THIS.ADDOBJECT("old"+ALLT(STR(i)),"dowlabel")
			us="no=this.old"+ALLT(STR(i))
			&us
			WITH no
				.LEFT=2+(i-1)*(.WIDTH+1)
				DO CASE
					CASE i=1
						.CAPTION=""
					CASE i=2
						.CAPTION=""
					CASE i=3
						.CAPTION=""
					CASE i=4
						.CAPTION=""
					CASE i=5
						.CAPTION=""
					CASE i=6
						.CAPTION=""
						.BACKCOLOR=RGB(254,0,0)
						.FORECOLOR=RGB(254,254,254)
					CASE i=7
						.CAPTION=""
						.BACKCOLOR=RGB(254,0,0)
						.FORECOLOR=RGB(254,254,254)
				ENDCASE
				.VISIBLE=.T.
			ENDWITH
		NEXT
		nomb=0
		FOR N=1 TO 6
			FOR i=1 TO 7
				nomb=nomb+1
				THIS.ADDOBJECT("oldy"+ALLT(STR(nomb)),"daylabel")
				us="no=this.oldy"+ALLT(STR(nomb))
				&us
				WITH no
					.TOP=57+(N-1)*(.HEIGHT+1)
					.LEFT=2+(i-1)*(.WIDTH+1)
					.VISIBLE=.T.
				ENDWITH
			NEXT
		NEXT
		THIS.DRAW
	ENDPROC

	PROCEDURE setday
		LOCAL fdd,fd,i,N,us
		fdd=CTOD("01."+ALLT(STR(THIS.vmonth))+"."+ALLT(STR(THIS.vyear)))
		fd=DOW(fdd)
		fd=IIF(fd=1,7,fd-1)
		FOR i=1 TO fd-1
			us="this.oldy"+ALLT(STR(i))+".visible=.f."
			&us
		NEXT
		FOR i=1 TO 40
			us="eobj=this.oldy"+ALLT(STR(fd+i-1))
			&us
			eobj.CAPTION=ALLT(STR(i))
			eobj.VISIBLE=.T.
			edat=CTOD(ALLT(STR(i))+"."+ALLT(STR(THIS.vmonth))+"."+ALLT(STR(THIS.vyear)))
			DO CASE
				CASE edat=THIS.vd
					eobj.BACKCOLOR=RGB(250,150,150)
					eobj.TOOLTIPTEXT=' '
				CASE edat=DATE()
					eobj.BACKCOLOR=RGB(150,250,150)
					eobj.TOOLTIPTEXT=''
				OTHERWISE
					eobj.BACKCOLOR=RGB(250,250,250)
					eobj.TOOLTIPTEXT=''
			ENDCASE
			IF MONTH(fdd)!=MONTH(fdd+i)
				EXIT
			ENDIF
		NEXT
		ezn=(fd+i-1)/7
		_colday=IIF(ezn=INT(ezn),ezn,INT(ezn)+1)
		THIS.HEIGHT=161-(17*(6-_colday))
		FOR N=fd+i TO 42
			us="this.oldy"+ALLT(STR(N))+".visible=.f."
			&us
		NEXT
	ENDPROC

	PROCEDURE DRAW
		THIS.vday=1
		THIS.olm.CAPTION=ALLT(STR(THIS.vday))+" "+THIS.mns[this.vmonth]+" "+ALLT(STR(THIS.vyear))
		THISFORM.setday
	ENDPROC

	PROCEDURE obml.CLICK
		IF THISFORM.vmonth=1
			THISFORM.vmonth=12
			THISFORM.vyear=THISFORM.vyear-1
		ELSE
			THISFORM.vmonth=THISFORM.vmonth-1
		ENDIF
		THISFORM.DRAW
	ENDPROC

	PROCEDURE obtd.CLICK
		THISFORM.vmonth=MONTH(DATE())
		THISFORM.vyear=YEAR(DATE())
		THISFORM.DRAW
	ENDPROC

	PROCEDURE obmr.CLICK
		IF THISFORM.vmonth=12
			THISFORM.vmonth=1
			THISFORM.vyear=THISFORM.vyear+1
		ELSE
			THISFORM.vmonth=THISFORM.vmonth+1
		ENDIF
		THISFORM.DRAW
	ENDPROC

	PROCEDURE obyl.CLICK
		THISFORM.vyear=THISFORM.vyear-1
		THISFORM.DRAW
	ENDPROC

	PROCEDURE obyr.CLICK
		THISFORM.vyear=THISFORM.vyear+1
		THISFORM.DRAW
	ENDPROC

	PROCEDURE CLICK
*		THIS.RELEASE
	ENDPROC
	PROCEDURE KEYPRESS
	LPARAMETERS nKeyCode, nShiftAltCtrl	
		THIS.RELEASE
	ENDPROC

	PROCEDURE tmer.INIT
		THIS.INTERVAL=100
	ENDPROC

	PROCEDURE tmer.TIMER
		LOCAL xval,yval
		xval=MROW(THISFORM.CAPTION,3)
		yval=MCOL(THISFORM.CAPTION,3)
		IF xval<0.OR.yval<0
			THIS.CYCL=THIS.CYCL+1
		ELSE
			THIS.CYCL=0
		ENDIF
		IF THIS.CYCL=10
			THISFORM.RELEASE
		ENDIF
	ENDPROC
ENDDEFINE




*************************************************************
*         alias
*************************************************************
*
*tcAlias -          ID
*************************************************************
* 
*   ,   ID
*  ,   NULL
*************************************************************
*
*       NOT NULL, 
*    ID      
*  ID    
*************************************************************
FUNCTION NewID(tcobjid)
  LOCAL lcAlias
  IF TYPE("tcobjid")<>"N" OR EMPTY(m.tcobjid)
	RETURN 0
  ENDIF

  LOCAL lnNewID
  lnNewID=NULL
  
  *     
  LOCAL lcReprocess, lnArea, lcError, llIsUsedTabLists
  lnArea = SELECT()
  lcReprocess = SET('REPROCESS')
  SET REPROCESS TO 3
  lcError=ON("ERROR")
  ON ERROR *	&&     
  llIsUsedTabLists=USED("SHBL")
  
  *     ,   
  IF m.llIsUsedTabLists=.F.
    USE KADR!SHBL IN 0 ORDER IDOBJ
  ENDIF
  
  * ,        
  *       ID  
  *         
  *        
  *  ActiveX 
  IF USED("SHBL") AND SEEK(m.tcobjid,"SHBL","IDOBJ")=.T. AND ;
  		ISRLOCKED(RECNO("SHBL"),"SHBL")=.F. AND RLOCK("SHBL")=.T.
    SELECT SHBL
    REPLACE SHBL.MaxID WITH SHBL.MaxID+1
	IF CursorGetProp('buffering','SHBL')>1 AND TableUpdate(.F.,.T.,'SHBL')=.F.
	  *          
	  *  ,    ,     
	  *   
      TableRevert(.F.,'SHBL')
    ELSE
	  lnNewID=SHBL.MaxID
	ENDIF
	UNLOCK RECORD RECNO("SHBL") IN SHBL
  ENDIF
  
  *    
  IF m.llIsUsedTabLists=.F.
  	USE IN SHBL
  ENDIF
  SELECT (m.lnArea)
  SET REPROCESS TO m.lcReprocess
  ON ERROR &lcError
  
  RETURN m.lnNewID
ENDFUNC
*************************************************************
*          alias
*************************************************************



PROC MYCLOSETABLES
LOCAL if_u
*!*	SET PATH TO DATA
*!*	IF !FCLOSE(FOPEN("KADR.DBC",12))
*!*		RETURN
*!*	ENDIF
IF ! USED("SHBL")
	USE KADR!SHBL ORDE IDOBJ IN 0
	if_u=.T.
ELSE
	if_u=.F.
	SELE SHBL
	SET ORDER TO idobj	
ENDIF

IF USED("WTAB")
	SELE WTAB
	USE
ENDIF
IF USED("CARD")
	USE IN "CARD"
ENDIF
IF USED("SPRV")
	USE IN "SPRV"
ENDIF
IF USED("CARM")
	USE IN "CARD"
ENDIF
IF USED("CARM")
	USE IN "CARD"
ENDIF
IF USED("DOCM")
	USE IN "DOCM"
ENDIF
IF USED("PRIC")
	USE IN "PRIC"
ENDIF
IF USED("PRIS")
	USE IN "PRIS"
ENDIF

IF USED("SHSP")
	USE IN "SHSP"
ENDIF

IF USED("SHST")
	USE IN "SHST"
ENDIF

IF USED("VIBR")
	USE IN "VIBR"
ENDIF
IF USED("FVIB")
	USE IN "FVIB"
ENDIF

IF USED("SVAR")
	USE IN "FVIB"
ENDIF

ll_yy=.F.
SELE 0
TRY
USE KADR!WTAB EXCL 
***********************************
RECA ALL
DELE ALL FOR MONN=0
PACK
REPL ALL COD WITH RECNO()
***********************************
GO BOTT
LOCAL MAXI,maxc,maxm,maxp,maxd,maxs
MAXI= IIF(!EOF(),COD,0)
USE
USE KADR!SPRV EXCLUSIVE 
***********************************
RECA ALL
DELE ALL FOR idcls=0
PACK
***********************************
USE
USE KADR!SHST EXCLUSIVE ORDE  ID
RECA ALL
DELE ALL FOR ID=0
PACK
GO BOTT
maxss= IIF(!EOF(),ID,0)
USE
USE KADR!SHSP EXCLUSIVE 
***********************************
RECA ALL
DELE ALL FOR id=0
PACK
***********************************
*O BOTT
*axc= IIF(!EOF(),tabn,0)
USE
USE KADR!CARD EXCLUSIVE ORDE tabn
***********************************
RECA ALL
DELE ALL FOR tabn=0
PACK
***********************************
GO BOTT
maxc= IIF(!EOF(),tabn,0)
USE
USE KADR!CARM EXCLUSIVE ORDE ID
***********************************
RECA ALL
DELE ALL FOR tabn=0 OR ID=0
PACK
***********************************
GO BOTT
maxm= IIF(!EOF(),ID,0)
USE
USE KADR!PRIC EXCLUSIVE ORDE ID
***********************************
RECA ALL
DELE ALL FOR  ID=0
PACK
***********************************
GO BOTT
maxp= IIF(!EOF(),ID,0)
USE
USE DOCM EXCLUSIVE ORDE ID
RECA ALL
DELE ALL FOR ID=0
PACK
GO BOTT
maxd= IIF(!EOF(),ID,0)
USE

USE KADR!PRIS EXCLUSIVE ORDE ID
***********************************
RECA ALL
DELE ALL FOR PRID=0 OR VID=0
PACK
***********************************
GO BOTT
maxs= IIF(!EOF(),ID,0)
USE


USE KADR!KARX EXCLUSIVE ORDE ID
***********************************
RECA ALL
DELE ALL FOR ID=0 OR VID=0
PACK
***********************************


GO BOTT
maxk= IIF(!EOF(),ID,0)
USE
USE VIBR EXCLUSIVE 
DELE ALL FOR IDDOCM=0
PACK
USE
USE FVIB EXCLUSIVE 
DELE ALL FOR ID=0
PACK
USE
USE SVAR EXCLUSIVE 
DELE ALL FOR IDDOCM=0
PACK
USE
USE KONT EXCLUSIVE 
DELE ALL FOR ID=0
PACK
USE
ll_yy=.T.
CATCH TO o_ERR
ll_yy=.F.
ENDTRY

IF ll_yy
	SELE SHBL
	IF SEEK(3)
		REPL MAXID WITH MAXI
	ENDIF
	IF SEEK(4)
		REPL MAXID WITH maxc
	ENDIF
	IF SEEK(41)
		REPL MAXID WITH maxm
	ENDIF
	IF SEEK(5)
		REPL MAXID WITH maxp
	ENDIF
	IF SEEK(6)
		REPL MAXID WITH maxd
	ENDIF
	IF SEEK(51)
		REPL MAXID WITH maxs
	ENDIF
	IF SEEK(42)
		REPL MAXID WITH maxk
	ENDIF
	IF SEEK(2)
		REPL MAXID WITH maxss
	ENDIF
ENDIF
IF if_u
	USE	
ENDIF
RETU


*!*	FUNCTION GetCurrentLine(RichTextBox1)
*!*	Private Const EM_LINEFROMCHAR = &HC9 Private Const EM_LINEINDEX = &HBB  



* 
*   ,       
* 
FUNCTION __
LPARAMETERS ld,ld2, lnYears, lnMonths,lnDays 
LOCAL lnDay, lnMonth, lnPlus, lnThisDay, lnThisMonth, lnThisYear, lnYear 

IF ld>ld2 
lnPlus=ld 
ld=ld2 
ld2=lnPlus 
ENDIF 
IF EMPTY(ld) 
ld = {^2000.01.01} 
lnPlus=2000 
ELSE 
lnPlus=0 
ENDIF 

lnYear=YEAR(ld) 
lnMonth=EVL(MONTH(ld),1) 
lnDay=EVL(DAY(ld),1) 

lnThisYear = YEAR(ld2) 
lnThisMonth=MONTH(ld2) 
lnThisDay=DAY(ld2) 

lnYears=lnThisYear-lnYear 
IF GOMONTH(ld,lnYears*12) > ld2 
lnYears=lnYears-1 
ENDIF 
lnYear = lnYear + lnYears 
ld=GOMONTH(ld,lnYears*12) 

lnMonths=lnThisMonth-lnMonth + IIF(lnYear=lnThisYear,0,12) 
IF GOMONTH(ld,lnMonths)>ld2 
lnMonths=lnMonths-1 
ENDIF 
lnMonth = lnMonth + lnMonths - IIF(lnYear=lnThisYear,0,12) 

lnDays = ld2-GOMONTH(ld,lnMonths) 
lnYears =lnYears+lnPlus 
*RETURN TEXTMERGE('<<lnYears>>,<<lnMonths>>,<<lnDays>>')
RETURN lnYears*100*100+lnMonths*100+lnDays

FUNCTION _
LPARAMETERS ld,ld2, lnYears, lnMonths,lnDays 
LOCAL lnDay, lnMonth, lnPlus, lnThisDay, lnThisMonth, lnThisYear, lnYear 

IF ld>ld2 
lnPlus=ld 
ld=ld2 
ld2=lnPlus 
ENDIF 
IF EMPTY(ld) 
ld = {^2000.01.01} 
lnPlus=2000 
ELSE 
lnPlus=0 
ENDIF 

lnYear=YEAR(ld) 
lnMonth=EVL(MONTH(ld),1) 
lnDay=EVL(DAY(ld),1) 

lnThisYear = YEAR(ld2) 
lnThisMonth=MONTH(ld2) 
lnThisDay=DAY(ld2) 

lnYears=lnThisYear-lnYear 
IF GOMONTH(ld,lnYears*12) > ld2 
lnYears=lnYears-1 
ENDIF 
lnYear = lnYear + lnYears 
ld=GOMONTH(ld,lnYears*12) 

lnMonths=lnThisMonth-lnMonth + IIF(lnYear=lnThisYear,0,12) 
IF GOMONTH(ld,lnMonths)>ld2 
lnMonths=lnMonths-1 
ENDIF 
lnMonth = lnMonth + lnMonths - IIF(lnYear=lnThisYear,0,12) 

lnDays = ld2-GOMONTH(ld,lnMonths) 
lnYears =lnYears+lnPlus 
RETURN lnYears


FUNCTION staj
LPARAMETERS DATE1,DATE2
IF EMPTY(date1)
	date1={^2000-01-01}
ENDIF

IF EMPTY(date2)
	date2=DATE()
ENDIF

y1=Year(DATE1)
m1=Month(DATE1)
d1=Day(DATE1)


y2=Year(DATE2)
m2=Month(DATE2)
d2=Day(DATE2)

If d2>=d1
	d=d2-d1
Else
	d=(d2+30)-d1
	m2=m2-1
Endif

If m2>=m1
	m=m2-m1
	Y=y2-y1
Else
	m=(m2+12)-m1
	Y=(y2-1) -y1
Endif
*RETU TRANSFORM(Y,"@l 99")+'-'+TRANSFORM(m,"@l 99")+'-'+TRANSFORM(d,"@l 99")
RETU Y*100*100+m*100+d

PROCEDURE _
LPARAMETERS ln_j
LOCAL ly,lm,lc
ld=ln_j%100
lm=INT(ln_j/100)%100
ly=INT(ln_j/10000)
DO WHILE ld > 30 
	ld=ld-30
	lm=lm+1
ENDDO
DO WHILE lm>12
	lm=lm-12
	ly=ly+1
ENDDO
RETU ly*100*100+lm*100+ld


PROCEDURE EXTRAN
LPARAMETERS o_Sheet,m_col,m_row
LOCAL i_i,j_j,lc_cellvalue,prv_sel
prv_sel=SELECT()
IF USED("ctables")
	SELECT ctables
ELSE
	RETURN
ENDIF

FOR i_i=1 TO  m_row
	FOR j_j=2 TO  m_col
		lc_cellvalue=Nvl(o_Sheet.Cells(i_i,j_j).Value,'')
*		ACTIVATE SCREEN
		IF ! EMPTY(lc_cellvalue) AND TYPE("lc_cellvalue")=="C"
*			? lc_cellvalue
			IF "discontinued" $ lc_cellvalue
				o_Sheet.Cells(i_i,j_j).Value=STRTRAN(o_Sheet.Cells(i_i,j_j).Value,"discontinued","discontinu")
			ENDIF
*			susp
			SCAN all
				DO CASE
				CASE Tname="" 
*				UPPER(".") $ UPPER(lc_cellvalue) 

				CASE Tname=""
				OTHERWISE 
				
				ENDCASE
			ENDSCAN
		ENDIF 
	ENDFOR
ENDFOR
SELECT (prv_sel)
ENDPROC